CREATE DATABASE [Sprut]
	ON PRIMARY
		(NAME = N'Sprut', FILENAME = N'G:\Temp\Template\Sprut.mdf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
	FILEGROUP VOICE
		(NAME = N'Stream_1', FILENAME = N'G:\Temp\Template\Stream_1.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_2', FILENAME = N'G:\Temp\Template\Stream_2.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_3', FILENAME = N'G:\Temp\Template\Stream_3.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_4', FILENAME = N'G:\Temp\Template\Stream_4.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_5', FILENAME = N'G:\Temp\Template\Stream_5.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_6', FILENAME = N'G:\Temp\Template\Stream_6.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_7', FILENAME = N'G:\Temp\Template\Stream_7.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_8', FILENAME = N'G:\Temp\Template\Stream_8.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_9', FILENAME = N'G:\Temp\Template\Stream_9.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
		(NAME = N'Stream_10', FILENAME = N'G:\Temp\Template\Stream_10.ndf' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 5),
	FILEGROUP SECURITY
		(NAME = N'Security', FILENAME = N'G:\Temp\Template\Security.ndf' , SIZE = 1, MAXSIZE = UNLIMITED, FILEGROWTH = 10%)
	LOG ON (NAME = N'Sprut_log', FILENAME = N'G:\Temp\Template\Sprut_log.LDF' , SIZE = 10, MAXSIZE = UNLIMITED, FILEGROWTH = 10%)
	
COLLATE Cyrillic_General_CI_AS
GO 

USE Sprut
CREATE TABLE [Session] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[BeginDate] [datetime] NOT NULL ,
	[BeginTime] [datetime] NOT NULL ,
	[Duration] [int] NULL ,
	[Channel] [char] (64) COLLATE Cyrillic_General_CI_AS NULL ,
	[Call] [char] (127) COLLATE Cyrillic_General_CI_AS NULL ,
	[ANI] [char] (256) COLLATE Cyrillic_General_CI_AS NULL ,
	[Comment] [char] (255) COLLATE Cyrillic_General_CI_AS NULL ,
	[E1Caller] [char] (127) COLLATE Cyrillic_General_CI_AS NULL ,
	[E1Called] [char] (127) COLLATE Cyrillic_General_CI_AS NULL ,
	[E1Info] [int] NULL ,
	[VoiceId] [int] NOT NULL ,
	[PbxId] [int] NOT NULL ,
	[LineId] [tinyint] NOT NULL ,
	[Importance] [tinyint] NOT NULL ,
	[Category] [tinyint] NOT NULL ,
	[Connect] [tinyint] NOT NULL ,
	[Direct] [tinyint] NOT NULL ,
	[Empty] [bit] NOT NULL ,
	[Type] [tinyint] NOT NULL ,
	[Part] [int] NOT NULL ,
	[User] [char] (16) COLLATE Cyrillic_General_CI_AS NULL ,
	[Password] [char] (16) COLLATE Cyrillic_General_CI_AS NULL ,
	 PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
) ON [PRIMARY]

CREATE TABLE [Stream] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Voice] [image] NULL  DEFAULT (0x20),
	[Txt] [image] NULL  DEFAULT (0x20)
) ON [PRIMARY] TEXTIMAGE_ON [VOICE]


CREATE TABLE [Security] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Users] [image] NULL DEFAULT (0x20)
) ON [PRIMARY] TEXTIMAGE_ON [SECURITY]

CREATE TABLE [Info] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[SizeDB] [int] NOT NULL  DEFAULT (0),
	[CountDB] [int] NOT NULL DEFAULT (0),
	[Reserved1] [int] NOT NULL DEFAULT (0),
	[Reserved2] [int] NOT NULL DEFAULT (0),
	[Reserved3] [int] NOT NULL DEFAULT (0)
) ON [PRIMARY]
GO

CREATE TABLE [Extention] (
	[Id] [int] NOT NULL ,
	[Call] [char] (16) COLLATE Cyrillic_General_CI_AS NULL ,
) ON [PRIMARY]
GO

CREATE TABLE [SMDR] (
 [Timeslot] [int] NULL ,
 [DateEnd] [datetime] NULL ,
 [DateBegin] [datetime] NULL ,
 [Duration] [int] NULL ,
 [Extention] [char] (16) COLLATE Cyrillic_General_CI_AS NULL ,
 [Call] [char] (32) COLLATE Cyrillic_General_CI_AS NULL ,
 [FullInfo] [char] (128) COLLATE Cyrillic_General_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE  UNIQUE INDEX [SessionId] ON [dbo].[session]([Id]) ON [PRIMARY]
CREATE  INDEX [ExtentionCall] ON [dbo].[Extention]([Call])
CREATE  INDEX [SessionChannel] ON [dbo].[session]([Channel])
CREATE  INDEX [SessionCall] ON [dbo].[session]([Call])
CREATE  INDEX [SessionANI] ON [dbo].[session]([ANI])
CREATE  INDEX [SessionCaller] ON [dbo].[session]([E1Caller])
CREATE  INDEX [SessionCalled] ON [dbo].[session]([E1Called])
CREATE  INDEX [SessionLineId] ON [dbo].[session]([LineId])
CREATE  INDEX [SessionDirect] ON [dbo].[session]([Direct])
CREATE  INDEX [SessionVoiceId] ON [dbo].[session]([VoiceId])
CREATE  INDEX [SessionDate] ON [dbo].[session]([BeginDate])
CREATE  INDEX [SessionTime] ON [dbo].[session]([BeginTime])
CREATE  INDEX [SessionDateTime] ON [dbo].[session]([BeginDate],[BeginTime])
CREATE  INDEX [SessionDuration] ON [dbo].[session]([Duration])
CREATE  INDEX [SessionType] ON [dbo].[Session]([Type])

GO

create proc PutSecurityUsersBlock
	@dwOffset int,
	@dwDelete int,
	@ptrBlock image,
	@ptrAddress varbinary(16)
as
 SET TEXTSIZE 131072
 updatetext security.users @ptrAddress @dwOffset @dwDelete @ptrBlock
GO

create proc PutStreamTxtBlock
	@dwOffset int,
	@dwDelete int,
	@ptrBlock image,
	@ptrAddress varbinary(16)
as
 SET TEXTSIZE 131072
 updatetext stream.txt @ptrAddress @dwOffset @dwDelete @ptrBlock
GO
create proc PutStreamVoiceBlock
	@dwOffset int,
	@dwDelete int,
	@ptrBlock image,
	@ptrAddress varbinary(16)
as
 SET TEXTSIZE 131072
 updatetext stream.voice @ptrAddress @dwOffset @dwDelete @ptrBlock
GO
